

#include "config.h"
/*
#define LOW_PWM	//__
#define LOTOK_ONE_SW	//   
#define REVERS_RELE		//    
#define katod//    .   
*/

//#define TIME_ON_VLAG	150	// .  

#if defined(LOTOK_ONE_SW)
#warning ONE_SWT_
#elif defined(AKTUATOR)
#warning AKTUATOR	
#else
#warning     	
#endif

#ifdef LOW_PWM
#warning LPWM_
#else
#warning FI_	
#endif

#ifndef AKTUATOR
	#ifdef REVERS_RELE
	#warning RELE_
	#else
	#warning VT_	
	#endif
#endif

#ifdef KSHM
	#warning KSHM - 	
#endif

#ifdef katod
#warning OK
#else
#warning OA	
#endif


//--------------------------------
#define BTN_TEMPER		_BV(1) 	//
#define BTN_TIME_OFF	_BV(3)  //PLUS   
#define BTN_DS2			_BV(2)  //MINUS  . 
#define SWT_F_KONZEVIK	_BV(4) 
#define SWT_R_KONZEVIK	_BV(5) 

//---------PORTB-PORTC---------
#define PINLED	PINB
#define PORTLED	PORTB
#define	DDRLED	DDRB
#define	PORTZN	PORTC
#define DDRZN	DDRC
#define PINZN	PINC
#define	ZN0		_BV(4)
#define	ZN1		_BV(3)
#define	ZN2		_BV(2)
//#define	ZN0		_BV(2)
//#define	ZN1		_BV(3)
//#define	ZN2		_BV(4)
#define	BITZN	(ZN0|ZN1|ZN2)

#define	PORT_SEG_GH	PORTC
#define	DDR_SEG_GH	DDRC
#define	SEGZ_1		_BV(0)
#define	SEGZ_2		_BV(1)


//------------------------
#define TRIAC		D,3,H
#define ALARM_LED	C,5,H

//----------74HC595-------------
#define DATA	B,6,H
#define SHIFT	D,4,H
#define STORAGE	B,7,H



//#define OUT_ALARM_LED		_BV(0)
#define OUT_DAMAGE_COOL		_BV(6)
#define OUT_ON_NAGREV		_BV(1)
#define OUT_SILOVOE_RELE	_BV(7)
#define OUT_ZUMER			_BV(0)
#define OUT_MOTOR			_BV(5)
#define OUT_MOTOR_REVERS	_BV(4)
#define OUT_DIFFERENCE_T	_BV(2)
#define OUT_VLAG			_BV(3)



//-----------DS18B20------------
#define	PORT_1wire	PORTD
#define	DDR_1wire	DDRD
#define	PIN_1wire	PIND
#define	PWIRE_0 		_BV(5)	// DQ DS18B20
#define	PWIRE_1 		_BV(6)	// DQ DS18B20
#define	PWIRE_2 		_BV(7)	// DQ DS18B20
//-----------------------------

//#define TIME_T1(tim)	(  ( tim/(1/F_CPU*64) ) )
#define TIME_T1(tim)	( (uint16_t)  ( tim/6.4e-5 ) )

#define sA	_BV(1)
#define sB	_BV(0)
#define sC	_BV(4)
#define sD	_BV(6)
#define sE	_BV(7)
#define sF	_BV(2)
#define sG	_BV(3)
#define sH	_BV(5)
/*		 -A-
		F	B
		 -G-
		E	C
		 -D-	*/
const uint8_t font[]={
sA|sB|sC|sD|sE|sF,//0
sB|sC,//1
sA|sB|sG|sE|sD,//2
sA|sB|sG|sC|sD,//3
sF|sG|sB|sC,//4
sA|sF|sG|sC|sD,//5
sA|sF|sG|sC|sD|sE,//6
sA|sB|sC,//7
sA|sB|sC|sD|sE|sF|sG,//8
sA|sB|sC|sD|sG|sF,//9
sA|sD|sE|sF|sG,//E
sD|sE|sF|sG,//t
sB|sC|sD|sE|sG,//d
sA|sB|sC|sE|sF|sG,//A
sA|sB|sE|sF|sG,//P
sB|sC|sD|sF|sG,//
sA|sD|sE|sF,//C
sA|sE|sF|sG,//F
sC|sE|sG,//n
sF|sE|sD|sC|sB,//U
sC|sD|sE|sG,//o
};

#define f_e	10
#define f_t	11
#define f_d	12
#define f_a	13
#define f_P	14
#define f_y 15
#define f_C 16
#define f_F 17
#define f_n 18
#define f_U 19
#define f_o 20


#define	ALRM_DFRN_T	_BV(0)//   1  2   1,5.
#define ALRM_LOW_T	_BV(1)
#define ALRM_HI_T	_BV(2)
#define	ALRM_EEP	_BV(3)
#define	ALRM_SENS	_BV(4)
#define ALRM_SWT_ERROR	_BV(5)

prog_int8_t osccal=0xFF;

//static uint16_t Time1gr;

static uint8_t	led_buffer[3], led_buffer_vlag[3], znmesto, state_wire, TriacGate, power_flag, tmp_power=1,
				state, time_blank, alarm_T, status_nagrev,
				out_1wire, temperature[4], time_wire, 
				bcd_num2,bcd_num3,bcd_num4,
				eeprom_err, 
				swt_konzevik, key,  inc, show_vlagnost, on_out_vlagnost, Vlagnost,   
				antdr, count_press, povtor, blank,
				revers, state_motor, time_state,
				Outs_HC595;
int32_t Time_Motor;

static int16_t porog=(int16_t)(35*16), Temp_DS0, Temp_DS1, Old_Temperatura;//, Temp_DS2;
static int16_t tmp_int16, time_vlagnost;

#define Tim_Pause(tim)	( (tim/0.004)+1 ) 
const uint8_t pause_after_press[]={Tim_Pause(0.55), Tim_Pause(0.5), Tim_Pause(0.41), Tim_Pause(0.33), Tim_Pause(0.25), Tim_Pause(0.20), Tim_Pause(0.15), Tim_Pause(0.1)}; 

struct	setup{
		int16_t correction_ds[3];
		int16_t porog;
		int16_t DeltaT;
		int16_t AlarmT;
		int16_t vlagnost;
		int16_t time_lotok_pause;
		int16_t time_lotok_on;
		int16_t TimeOnVlagnost;
		int16_t TimePauseVlagnost;
		int16_t PowerConstTime;
		uint16_t crc;
} setup;


	
enum {ST_0=0, ST_INPUT_REG, 
ST_SET_T,ST_SET_T_ALARM, ST_SET_T_1,ST_SET_T_ALARM_1,ST_SET_DELTA_T, ST_POWER_CONST, ST_POWER_CONST_1,
ST_FORCE_POVOROT, ST_MANUAL_MOVE, ST_MANUAL_MOVE_1, ST_MANUAL_MOVE_2,
ST_TIM_OFF, ST_TIM_OFF_1, 
ST_SET_VLAG, ST_SET_VLAG_POROG, ST_SET_VLAG_T_ON, ST_SET_VLAG_PAUSE, ST_VLAG_WORK_EDIT, 
ST_COR_IN_DS0, ST_COR_IN_DS1, ST_COR_IN_DS2, ST_COR_1, ST_COR_2, ST_COR_RH, ST_SET_DELTA_T_1,
ST_SHOW_VLAGNOST,
ST_STORE_EEP};


//-------------EEPROM-----------------
#define ADR_EEP		10
//------------------------------------

//static uint8_t antdr_swt=0;
