
#include <avr/io.h>
#include "pin_macros.h"

#define DHT11_PIN D,7,H

#define DHT11_OK	1
#define DHT11_ERROR	0

#define TIME_RESPONSE 150
#define TIME_WAIT_US(t) ((uint16_t)( ((F_CPU/8)*(t))/1000000 ))


extern uint8_t Dth11Byte[5], FlagDth11, StateDth11;
extern void dht11_getdata(void);

enum ST_DHT11{DHT_START, DHT_LOWBUS, DHT_RECEIVE, DHT_END, DHT_STOP};

/*
DHT11  20-90%RH 5%RH 
0-50`C 2`C 
Dth11Byte[0] -  RH
Dth11Byte[2] -  `C
Dth11Byte[4] -	chek sum
*/
