//v0.02

#include <avr/io.h>
#include "lpwm.h"

#if defined (LOW_PWM)

int16_t TimPause, OnOutTime;
static uint8_t OutState, Count, Power, Pw, OnPw, TimStill;//, countPrir;
static int16_t TimePowerCurrent;
static int16_t Ttreck[10];
int8_t Prir, OldPrir;//, pr;

//----------------------__----------------------------

void regulyator(int16_t CurentTemperatur, int16_t PorogT){
//-------------------------------------------------------------------
	//Ttreck
	for (uint8_t j=sizeof(Ttreck)/2-1 ; j>0 ; j-- ){//    
		Ttreck[j]=Ttreck[j-1];
		}
	Ttreck[0]=CurentTemperatur;
	

	Prir=0;
	int16_t PrirL=0;
	for (uint8_t j=0; j<sizeof(Ttreck)/2-1 ; j++ ){//  
		PrirL+= (signed int)(Ttreck[j]-Ttreck[j+1]);
		}
	if (PrirL > 127) PrirL=127;
	if (PrirL <-127) PrirL=-127;
	Prir=PrirL;

	if (++Count>=7) Count=0;

	if ( CurentTemperatur <= PorogT )//---------------------- ---------------------
		{
		int16_t Tim=TimPause;
		if ( CurentTemperatur+(uint16_t)(0.5*16) > PorogT ){//     
			if (Prir<=OldPrir) {
				Power=1;
				}
			if ( CurentTemperatur+2 > PorogT ){
				//if (Prir>1) 
				//	if (Tim<OnOutTime) Tim=OnOutTime;
				if (Prir>0) {//26.05.15//if (Prir>1) 
					Power=0; 
					//if (Count==0) Tim+=1;
					}
				}
			
			if (Prir>3) {//26.05.15//if (Prir>4) 
				Power=0; 
				//Tim+=2;//
				Tim+=1;//
				}
				else{
				if (Count==0){
					if (Prir < OldPrir) Tim-=1;
					if ( (CurentTemperatur < PorogT) && (Prir<=0) ) Tim-=2;
						//if ( (CurentTemperatur < PorogT) && (Prir<=0) ) Tim-=1;
					}
				}
				
			if ( (CurentTemperatur < PorogT) && (Prir<=0) )	{//     ,
				if (TimStill<=20) {	//      10    
					TimStill++;
					}
					else{
					if ((Tim - OnOutTime*2)>0) Tim-=10;//     
					Tim-=1;
					Power=1;
					}
				}
				else
				TimStill=0;
			
			TimPause=Tim;
			}//-------------------------------------------------------------------
			
		if ( CurentTemperatur <= PorogT-(uint16_t)(0.5*16) ){//    0.5  
			int16_t Tim=TimPause;
			if (Power==0){
				if (Prir<OldPrir) Power=1;
				}
			if (Prir>=3) if ( CurentTemperatur >= PorogT-16 ) Power=0; //     1  13.05.2015
			if (Prir>=7) {
				Tim+=1;
				if (Prir>=9) {
					Power=0;
					Tim+=1;
					}
				}
			if (Prir<3) {
				Tim--; 
				if (Prir < -1) Tim-=1; 
				if (Prir < -5) Tim-=2; 
				}
			TimPause=Tim;
			}
				
		if ( CurentTemperatur < PorogT-(uint16_t)(4*16) ){//    4  
			TimPause=0;
			//if ( CurentTemperatur > PorogT-(uint16_t)(4.4*16) ) TimPause=OnOutTime>>1;
			if (Prir>=10) Power=0; else Power=1;
			}
		}//---END------------------- ---------------------
	
	//---------------------- ---------------------
	if ( CurentTemperatur > PorogT ){
	//if ( CurentTemperatur >= PorogT ){
	int16_t Tim=TimPause;
		Power=0;
	
		if ( Prir<=0){// ,    
			if (++OnPw>=4) {
				if ( CurentTemperatur < PorogT+3 ) Power=1; 
				}
			if (TimStill<15)
				TimStill++;
				else
				Power=0; 
			}
			else 
			{
			OnPw=0;
			TimStill=0;
			}
	
		if ( Prir<0) {//  
			if ( CurentTemperatur > PorogT+4 ){ 
				if ( Prir<-3) Power=1; //    4    -3  
				}
				else 
				Power=1;//     
				
			if ( CurentTemperatur < PorogT+2 ) Tim--;
			if (Count==0) if ( Prir<-1) Tim--;
			}
			else{
			if (Prir>0)
				Tim+=1;
			}
		if (Count==0) Tim+=1;	
		TimPause=Tim;
		}//---END------------------- ---------------------

	OldPrir=Prir;
}	

uint8_t lpwm_out(void){
//---------------__-----------------
	if (TimPause < 0) TimPause=0;
	if (TimPause > 10000) TimPause=10000;

	if (OutState){
		if (--TimePowerCurrent<=0){
			TimePowerCurrent=TimPause;
			OutState=0;
			//if (Power==0) 
			Pw=0;
			}
		}
	if (OutState==0){
		if (--TimePowerCurrent<=0){
			TimePowerCurrent=OnOutTime;
			OutState=1;
			if (Power) 	Pw=1; else Pw=0;
			}
		}
		
	return (OutState && Pw);
}

#endif	
